<?php
//Before print delete.
add_action( 'admin_action_dupsltplate', 'abcfsl_autil_duplicate_tplate' );
add_action( 'admin_action_dupslmember', 'abcfsl_autil_duplicate_staff_member' );

//Duplicate SL template
function abcfsl_autil_duplicate_tplate(){

    if (! ( isset( $_GET['post']) || isset( $_POST['post'])  || ( isset($_REQUEST['action']) && 'dupsltplate' == $_REQUEST['action'] ) ) ) {
            wp_die('No post to duplicate has been supplied!');
            exit;
    }

    //get the original post id
    $postID = (isset($_GET['post']) ? $_GET['post'] : $_POST['post']);

    $post = get_post( $postID );
    if (!isset( $post )) { wp_die('Post creation failed, could not find original post: ' . $postID); }
    if ($post == null) { wp_die('Post creation failed, could not find original post: ' . $postID); }

    $out = abcfsl_autil_duplicate_template($postID, $post);
    if( $out == 'KO' ){ wp_die('Post creation failed: ' . $postID);}

    wp_redirect( admin_url( 'edit.php?post_type=cpt_staff_lst' ) );
    exit;
}

//Duplicate SL template
function abcfsl_autil_duplicate_staff_member(){

    if (! ( isset( $_GET['post']) || isset( $_POST['post'])  || ( isset($_REQUEST['action']) && 'dupslmember' == $_REQUEST['action'] ) ) ) {
            wp_die('No post to duplicate has been supplied!');
            exit;
    }

    //get the original post id
    $postID = (isset($_GET['post']) ? $_GET['post'] : $_POST['post']);

    $post = get_post( $postID );
    if (!isset( $post )) { wp_die('Post creation failed, could not find original post: ' . $postID); }
    if ($post == null) { wp_die('Post creation failed, could not find original post: ' . $postID); }

    $out = abcfsl_autil_duplicate_template( $postID, $post );
    if( $out == 'KO' ){ wp_die('Post creation failed: ' . $postID );}

    wp_redirect( admin_url( 'edit.php?post_type=cpt_staff_lst_item' ) );
    exit;
}


//Create a copy of template.
function abcfsl_autil_duplicate_template( $postID, $post ) {

    $out = 'KO';
    $newTitle = $post->post_title . ' - Copy';
    $postData = array(
            'comment_status' => $post->comment_status,
            'ping_status'    => $post->ping_status,
            'post_author'    => $post->post_author,
            'post_content'   => $post->post_content,
            'post_excerpt'   => $post->post_excerpt,
            'post_name'      => $post->post_name,
            'post_parent'    => $post->post_parent,
            'post_password'  => $post->post_password,
            'post_status'    => 'publish',
            'post_title'     => $newTitle,
            'post_type'      => $post->post_type,
            'to_ping'        => $post->to_ping,
            'menu_order'     => $post->menu_order
    );

    //Duplicate post
    $newPostID = wp_insert_post( $postData );

    if ( is_wp_error( $newPostID ) ) { return $out; }
    if (!$newPostID) { return $out; }

    wp_update_post( array('ID' => $newPostID, 'post_title'   => $newTitle . ' ' . $newPostID ) );

    //Duplicate all post meta.
    abcfsl_dba_duplicate_post_meta( $postID, $newPostID );

   return 'OK';
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//Add new field to meta fields order. If field already exists exit with no updates.
//Called from save template.
function abcfsl_autil_add_new_field_to_field_order( $tplatID, $showField, $showOn, $F ){

    $show = false;

    if ( $F == 'SPTL' || $F == 'SL' ){
        //$showField N, Y, H
        switch ( $showField ) {
            case 'Y':
            case 'H':
                $show = true;
                break;
            default:
                return;
        }
    }
    else{
        //Hide/Delete N, H, D
        switch ( $showField ) {
            case 'N':
            case 'H':
                $show = true;
                break;
            default:
                return;
        }
    }

    if( !$show ) { return ; }

    //Show On Y, L, S
    switch ( $showOn ) {
        case 'Y':
            abcfsl_autil_update_field_order_wrap( $tplatID, $F, false );
            abcfsl_autil_update_field_order_wrap( $tplatID, $F, true );
            break;
        case 'L':
            abcfsl_autil_update_field_order_wrap( $tplatID, $F, false );
            break;
        case 'S':
            abcfsl_autil_update_field_order_wrap( $tplatID, $F, true );
            break;
        default:
            break;
    }

}

//Update meta field order. Add new field. If field already exists exit with no updates.
function abcfsl_autil_update_field_order_wrap( $tplatID, $F, $isSingle ){

    $tplateOptns = get_post_custom( $tplatID );
    $fieldOrderL = isset( $tplateOptns['_fieldOrder'] ) ? $tplateOptns['_fieldOrder'][0] : '';

    if( $isSingle ){
        $fieldOrderS = isset( $tplateOptns['_fieldOrderS'] ) ? $tplateOptns['_fieldOrderS'][0] : '';
        abcfsl_autil_update_field_order( $tplatID, '_fieldOrderS', $fieldOrderS, $fieldOrderL, $F );
    }
    else {
        abcfsl_autil_update_field_order( $tplatID, '_fieldOrder', $fieldOrderL, $fieldOrderL, $F );
    }
}

//Add new field to meta: fields order. If field already exists exit with no updates.
function abcfsl_autil_update_field_order( $postID, $metaFieldName, $dataToUpdate, $fieldOrderL, $F ){

    $metaToUpdateExists = true;
    //Check if new meta field exists. Empty or populated.
    if( empty( $dataToUpdate ) ){  $metaToUpdateExists = false; }

    //There is already metadata. Update it
    if( $metaToUpdateExists ){
        abcfsl_autil_update_meta_field_order( $postID, $metaFieldName, $dataToUpdate, $F );
        return;
    }

    //Check if L meta exists.
    if( empty( $fieldOrderL ) ){ $metaToUpdateExists = false; }

    //No meta exists. Add a new meta + new field. Exit.
    if( !$metaToUpdateExists ){
        abcfsl_autil_add_meta_field_order( $postID, $metaFieldName, $F );
        return;
    }
}

//No legacy and no new. Add new option with a single field (first one)
function abcfsl_autil_add_meta_field_order( $postID, $metaFieldName, $F ){

    $metaValue[1] = $F;
    update_post_meta( $postID, $metaFieldName, $metaValue );
}

//Meta field exists.
function abcfsl_autil_update_meta_field_order( $postID, $metaFieldName, $metaData, $F ){

    //meta field exists.
    //Check if field is already present in an array if so exit. Otherwise add a new field and exit.
    $metaDataArray = unserialize( $metaData );

    //Check if field is already in an array. If so exit.
    if (in_array($F, $metaDataArray)) {
        return;
    }
    //FIELDS_50
    
    //for ( $i = 1; $i <= 41; $i++ ) {
    //Add new field to first available key and exit.
    for ( $i = 1; $i <= 51; $i++ ) {    
        if(!isset($metaDataArray[$i])){
           $metaDataArray[$i] = $F;
           update_post_meta( $postID, $metaFieldName, $metaDataArray );
           return;
        }
    }
}
