<?php
//Called from shortcode. Returns  menu HTML. Not linked to a page. Page has two shortcodes: menu and staff.
//Replaces deleted shortcodes cat and a-z menus. For backward compatibility. 
function abcfsl_cnt_menu_from_menu_shortcode( $scodeArgs ){

    $menuNo = $scodeArgs['menu-id'];
    $ajax = $scodeArgs['ajax'];

    $menu = abcfsl_util_menu_defaults();
    if( !abcfsl_util_menu_has_menu( $menuNo ) ) { return $menu; }

    $menuPar['menuType'] = substr( $menuNo, 0, 3 );
    $menuPar['menuID'] = substr( $menuNo, 4 );
    $scodeMenuType = $menuPar['menuType']; 

    global $post;
    $postID  = $post->ID;

    //Menu ID and Type is always set in shortcode (menu No). Disregard Template MenuID if selected.
    switch ( $scodeMenuType ) {
        case 'CAT':
        case 'AZM':
            $menuPar['pageURL'] = abcfsl_cnt_menu_pageURL( $postID, $ajax );
            $menu = abcfsl_cnt_menu_builder( $scodeArgs, $menuPar );        
        default:
            break;
    } 
    return $menu;
}

/*
 * ADDED AJAX
 *Called from cnt.php.
 * Returns array menu : HTML, menu options and qry parameters OR qry parameters.
 */
//============================================================
function abcfsl_cnt_menu_from_staff_shortcode( $menuNo, $scodeArgs, $filters, $ajaxMFP, $ajax ){

    $menu = abcfsl_util_menu_defaults();
    if( !abcfsl_util_menu_has_menu( $menuNo ) ) { return $menu; }
    
   //Menu option selected: Menu or Shortcode.
   $menuPar['menuType'] = substr( $menuNo, 0, 3 );
   $menuPar['menuID'] = substr( $menuNo, 4 );
   $scodeMenuType = $menuPar['menuType']; 

   //Menu ID and Type is always set in shortcode (menu No). 
   //Disregard Template MenuID if selected.
   switch ( $scodeMenuType ) {
       case 'CAT':
       case 'AZM':
            global $post;
            $postID = $post->ID;
            $menuPar['pageURL'] = abcfsl_cnt_menu_pageURL( $postID, $ajax );
            return abcfsl_cnt_menu_builder( $scodeArgs, $menuPar );        
       case 'MTF':
           $menu['menuID'] = $menuPar['menuID'];
           $menu['menuType'] = $scodeMenuType;
           $menu['pfixSL'] = $scodeArgs['prefix'];
           return abcfsl_cnt_filter_html( $menu, $filters, $scodeArgs, $ajaxMFP, $ajax );
       case 'MFP':
            $menu['menuID'] = $menuPar['menuID'];
            $menu['menuType'] = $scodeMenuType;
            $menu['pfixSL'] = $scodeArgs['prefix'];

            //WHY abcfslt ????????????????????????
            if ( function_exists( 'abcfslt_cnt_frm_builder_MFP' ) ){  
                return abcfslt_cnt_frm_builder_MFP( $menu, $filters, $ajaxMFP, $ajax );
            }
            if ( function_exists( 'abcfsls_cnt_filter_html' ) ){  
                return abcfsls_cnt_filter_html( $menu, $filters, 'abcfsl', $ajaxMFP, $ajax );
            }
           return $menu;
        default:
           break;

        //    case 'MFP':
        //     //SLS installed
        //     if ( !function_exists( 'abcfsls_cnt_filter_html' ) ){ return $menu; }
        //     $menu['menuID'] = $menuPar['menuID'];
        //     $menu['menuType'] = $scodeMenuType;
        //     $menu['pfixSL'] = $scodeArgs['prefix'];
        //     //return abcfsls_cnt_filter_html( $menu, $filters, $ajaxMFP, $ajax );
        //     return abcfsls_cnt_filter_html( $menu, $filters, 'abcfsl', $ajaxMFP, $ajax );


   }

   //== DEPRECATED  SECTION ?????  IF MENU-ID USED IN STAFF LIST SHORTCODE ================
   global $post;
   $postID = $post->ID;
   
   $menuPar['pageURL'] = get_permalink( $postID );

   //Template has MenuID selected. Return menu HTML & DB parameters.
   if( $scodeMenuType != 'SCD' ){ return abcfsl_cnt_menu_builder( $scodeArgs, $menuPar ); }

   //--- MENU SHORTCODE used as a Menu. Return only DB parameters. ------------------------
   //Check if URL has qry string. If so, get menu type and qry parameter.
   $menuQP = abcfsl_cnt_menu_from_staff_shortcode_qry_parameters( $scodeArgs, $menu );
   if( $menuQP['menuType']  != 'NONE' ) { return $menuQP; }

   //No qry string. Check if there is a menu shortcode.
   $menuCAT = abcfsl_cnt_menu_from_staff_shortcode_scode_cat( $scodeArgs, $menuPar['pageURL'], $menu );
   if( $menuCAT['menuType']  != 'NONE' ) {  return $menuCAT; }

   $menuAZ = abcfsl_cnt_menu_from_staff_shortcode_scode_az( $scodeArgs, $menuPar['pageURL'], $menu );
   if( $menuAZ['menuType']  != 'NONE' ) { return $menuAZ; }

   return $menu;
}

//===============================================================================
function abcfsl_cnt_menu_pageURL( $postID, $ajax ){

    if( $ajax > 0 ) { return ''; }
    return get_permalink( $postID );
}

//=============================================================
//URL has qry string. Get menu type and qry parameter.
function abcfsl_cnt_menu_from_staff_shortcode_qry_parameters( $scodeArgs, $menu ){

    $menuType = 'NONE';

    $qryFilterCAT = $scodeArgs['staff-category'];
    //$qryFilterCAT = $scodeArgs['category_name'];
    if( !empty( $qryFilterCAT ) ) { $menuType = 'CAT'; }

    $qryFilterAZM = $scodeArgs['staff-az'];
    if( !empty( $qryFilterAZM ) ) { $menuType = 'AZM'; }

    switch ( $menuType ) {
        case 'CAT':
            $menu['menuType'] = 'CAT';
            $menu['qryFilter'] = $qryFilterCAT;
            break;
        case 'AZM':
            $menu['menuType'] = 'AZM';
            $menu['qryFilter'] = $qryFilterAZM;
            $menu['filterField'] = abcfsl_cnt_menu_from_staff_shortcode_filter_field_az();
            break;
        default:
            break;
        }
    return $menu;
}

function abcfsl_cnt_menu_from_staff_shortcode_filter_field_az( ){

    global $post;
    $content = $post->post_content;
    $shortcode = 'abcf-staff-az-menu';
    $ff = '';
    if( has_shortcode( $content, $shortcode) ) {

        preg_match('/\['. $shortcode . '.*id=.(.*).\]/', $content, $ids);

        $menuID = 0;
        if(array_key_exists(1, $ids)){ $menuID = $ids[1]; }
        if( $menuID > 0 ){
            $menuOptns = get_post_custom( $menuID );
            $azFieldType = isset( $menuOptns['_azFieldType'] ) ? $menuOptns['_azFieldType'][0] : '';
            $azFieldID = isset( $menuOptns['_azFieldID'] ) ?  $menuOptns['_azFieldID'][0] : '';
            if($azFieldType == '' ) { $azFieldID = ''; }
            $ff = $filterField = $azFieldType . $azFieldID;
        }
    }
    return $ff;
}

function abcfsl_cnt_menu_from_staff_shortcode_scode_cat( $scodeArgs, $pageURL, $menuDefault ){

    global $post;
    $content = $post->post_content;
    $shortcode = 'abcf-staff-cat-menu';
    if( has_shortcode( $content, $shortcode) ) {

        //preg_match('/\[abcf-rggcl-cat-menu.*id=.(.*).\]/', $content, $ids);
        preg_match('/\['. $shortcode . '.*id=.(.*).\]/', $content, $ids);

        $menuID = 0;
        if(array_key_exists(1, $ids)){
            $menuID = $ids[1];
        }
        if( $menuID > 0 ){
            $menuPar['pageURL'] = $pageURL;
            $menuPar['menuType'] = 'CAT';
            $menuPar['menuID'] = $menuID;

            $menu = abcfsl_cnt_menu_builder( $scodeArgs, $menuPar );
            $menu['menuItemsHTML'] = '';
            return $menu;
        }
    }
    return $menuDefault;
}

function abcfsl_cnt_menu_from_staff_shortcode_scode_az( $scodeArgs, $pageURL, $menuDefault ){

    global $post;
    $content = $post->post_content;
    $shortcode = 'abcf-staff-az-menu';
    if( has_shortcode( $content, $shortcode) ) {

        preg_match('/\['. $shortcode . '.*id=.(.*).\]/', $content, $ids);

        $menuID = 0;
        if(array_key_exists(1, $ids)){
            $menuID = $ids[1];
        }
        if( $menuID > 0 ){
            $menuPar['pageURL'] = $pageURL;
            $menuPar['menuType'] = 'AZM';
            $menuPar['menuID'] = $menuID;

            $menu = abcfsl_cnt_menu_builder( $scodeArgs, $menuPar );
            $menu['menuItemsHTML'] = '';
            return $menu;
        }
    }

    return $menuDefault;
}
//======================================================
//Retuns array: Menu wrap with items + menu parameters
function abcfsl_cnt_menu_builder( $scodeArgs, $menuPar ){

    $pfix = $scodeArgs['prefix'];
    //$menuScode = $scodeArgs['menu-scode'];
    $menuID = $menuPar['menuID'];
    $menuType = $menuPar['menuType'];
    $pageURL = $menuPar['pageURL'];
    $qryFilter = '';

    // AJAX ------------------------
    //Ajax Menu have to use shortcode arg: menu-id. Otherwise it's no Ajax
    $scodeAjax = $scodeArgs['ajax'];
    $scodeMenuID = $scodeArgs['menu-id'];
    if( empty( $scodeMenuID ) ) { $scodeAjax = 0;}

    switch ( $menuType ) {
        case 'CAT':
            $qryFilter = $scodeArgs['staff-category'];
            break;
        case 'AZM':
            $qryFilter = $scodeArgs['staff-az'];
            break;
        default:
            break;
    }

    $menuOptns = get_post_custom( $menuID );
    $fCntrW = isset( $menuOptns['_fCntrW'] ) ? esc_attr( $menuOptns['_fCntrW'][0] ) : '';
    $fCntrCenter = isset( $menuOptns['_fCntrCenter'] ) ? esc_attr( $menuOptns['_fCntrCenter'][0] ) : 'Y';

    // TODO check if used?
    $fCntrCls = isset( $menuOptns['_fCntrCls'] ) ? esc_attr( $menuOptns['_fCntrCls'][0] ) : '';
    $fCntrStyle = isset( $menuOptns['_fCntrStyle'] ) ? esc_attr( $menuOptns['_fCntrStyle'][0] ) : '';

    //Plugin container CSS
    $cntrStyle = abcfl_css_w_responsive( $fCntrW, $fCntrW ) . $fCntrStyle;
    $centerCls = abcfsl_util_center_cls( $fCntrCenter, $pfix );
    $clsFItemsCntrMT = abcfsl_cnt_menu_cls_name_nc_bldr( isset( $menuOptns['_fItemsCntrMT'] ) ? esc_attr( $menuOptns['_fItemsCntrMT'][0] ) : 'N', 'MT', $pfix );
    $clsFItemsCntrMB = abcfsl_cnt_menu_cls_name_nc_bldr( isset( $menuOptns['_fItemsCntrMB'] ) ? esc_attr( $menuOptns['_fItemsCntrMB'][0] ) : 'N', 'MB', $pfix );
    $clsFtemMLR = abcfsl_cnt_menu_cls_name_nc_bldr( isset( $menuOptns['_fItemMLR'] ) ? esc_attr( $menuOptns['_fItemMLR'][0] ) : '10', 'FItemMLR', $pfix );

    //Menu container -----------------
    $cntCntrCls = ltrim( trim( $centerCls . ' ' . $clsFtemMLR . ' ' . $clsFItemsCntrMB . ' ' . $clsFItemsCntrMT ) );
    $div = abcfsl_cnt_menu_generic_div($pfix, 'FiltersCntr', $cntCntrCls, $cntrStyle);

    // AJAX ------------------------
    $menu = abcfsl_cnt_menu_items_cntr( $menuType, $qryFilter, $menuID, $menuOptns, '', '', $pfix, $pageURL, $scodeAjax );
    $menu['menuItemsHTML'] = $div['cntrS'] . $menu['menuItemsHTML'] . $div['cntrE'];

    return $menu;
}

//Retuns array: Menu container DIV + UL + Items AND parameters.
function abcfsl_cnt_menu_items_cntr( $menuType, $qryFilter, $menuID, $menuOptns, $baseCls, $customCls, $pfix, $pageURL, $scodeAjax){

    $ulCls = '';
    $menu = array();
    $itemsHTML = '';
    $ulID = $pfix . 'Filters';
    if( !empty($menuType) ) { $ulID = $pfix . $menuType; }
    //AJAX
    if( !empty($menuType) && $scodeAjax > 0 ) { $ulID = $pfix . 'Ajax' . $menuType . '_' . $scodeAjax; }

    $clsFItemColor = abcfsl_cnt_menu_cls_name_nc_bldr( isset( $menuOptns['_fItemColor'] ) ? esc_attr( $menuOptns['_fItemColor'][0] ) : 'D', 'FItemColor', $pfix );
    $clsFiltersCntr = trim ( $pfix . 'FItemsCntr_' . $menuID . ' ' . $pfix . 'FItemsCntr ' . $clsFItemColor . ' ' . $customCls );
    $fItemsCenter = isset( $menuOptns['_fItemsCenter'] ) ? esc_attr( $menuOptns['_fItemsCenter'][0] ) : 'Y';
    if($fItemsCenter == 'Y') { $ulCls = $pfix . 'TxtCenter'; }

    //Div, filters container.
    $divFiltersCntr = abcfsl_cnt_menu_generic_div( $pfix, $baseCls, $clsFiltersCntr, '' );

    switch ( $menuType ) {
        case 'CAT':
            $menu = abcfsl_cnt_menu_cat_items( $qryFilter, $menuID, $menuOptns, $pfix, $pageURL, $scodeAjax );
            break;
        case 'AZM':
            $menu = abcfsl_cnt_menu_az_items( $qryFilter, $menuOptns, $pfix, $pageURL, $scodeAjax );
            break;
        default:
            break;
    }
    $menu['menuID'] = $menuID;
    $menu['menuItemsHTML'] = $divFiltersCntr['cntrS'] . abcfl_html_tag( 'ul', $ulID, $ulCls ) . $menu['menuItemsHTML'] . abcfl_html_tag_end( 'ul'). $divFiltersCntr['cntrE'];
    return $menu;
}

//==============================================================
//Concatinate class name: prefix + BaseName + Value. Return empty if N or C. Return default if. 
function abcfsl_cnt_menu_cls_name_nc_bldr( $optnValue, $clsBaseName, $pfix ){

    if( $optnValue == 'N' ){ return ''; }
    if( $optnValue == 'C' ){ return ''; }
    if( $optnValue == 'D' ) { return ''; }
    if( empty( $optnValue) ) { return ''; }
    return ' ' . $pfix . $clsBaseName . $optnValue;
}

// generic DIV
function abcfsl_cnt_menu_generic_div( $pfix, $baseCls, $customCls, $customStyle ){

    $cntrCls = abcfsl_cnt_menu_class_bldr( $pfix, $baseCls, $customCls );

    $div['cntrS'] = abcfl_html_tag( 'div', '', $cntrCls, $customStyle );
    $div['cntrE'] = abcfl_html_tag_end( 'div');

    return $div;
}

function abcfsl_cnt_menu_class_bldr( $pfix, $baseCls, $customCls ){

    $cntrBaseCls = '';
    if( !empty( $baseCls ) ){ $cntrBaseCls = $pfix . $baseCls; }

    return  trim( $cntrBaseCls . ' ' . $customCls );
}

function abcfsl_cnt_menu_standard_div( $pfix, $baseCls, $customCls, $customStyle, $id='', $microdata='' ){

    $cntrCls = abcfsl_cnt_menu_class_bldr( $pfix, $baseCls, $customCls );

    //abcfl_html_tag( $element, $id, $cls='', $style='', $microdata='' )
    $div['cntrS'] = abcfl_html_tag( 'div', $id, $cntrCls, $customStyle, $microdata );
    $div['cntrE'] = abcfl_html_tag_end( 'div');

    return $div;
}


// function abcfsl_cnt_menu_default_optns_array(){

//     $minLen[1] = '3';
//     $minLen[2] = '3';
//     $minLen[3] = '3';
//     $minLen[4] = '3';
//     $minLen[5] = '3';
//     $minLen[6] = '3';

//     $menu['menuID'] = '';
//     $menu['pageURL'] = '';

//     $menu['first'] = '';
//     $menu['qryFilter'] = '';
//     $menu['menuType'] = 'NONE';

//     $menu['filterField'] = '';
//     $menu['filterType'] = '';

//     $menu['filter1Type'] = '';
//     $menu['filter2Type'] = '';
//     $menu['filter3Type'] = '';
//     $menu['filter4Type'] = '';
//     $menu['filter5Type'] = '';
//     $menu['filter6Type'] = '';

//     $menu['filter1Field'] = '';
//     $menu['filter2Field'] = '';
//     $menu['filter3Field'] = '';
//     $menu['filter4Field'] = '';
//     $menu['filter5Field'] = '';
//     $menu['filter6Field'] = '';

//     $menu['minLen'] = $minLen;

//     $menu['menuItemsHTML'] = '';
//     $menu['noDataMsg'] = '';
//     $menu['pfix'] = '';

//     return $menu;
// }
