<?php
//ALL CONTENT HTML. 
//Called from a shortcode. Used by all layouts.
//Calls individual layouts. menus, pagination.
//Adds AJAX script when ajax parameter is set. 
function abcfsl_cnt_html( $scodeArgs ){
    
    $pageNo = $scodeArgs['page'];
    $pfix = $scodeArgs['prefix'];
    $ajax = $scodeArgs['ajax'];
    $staffID = $scodeArgs['staff-id'];
    $searchForm = $scodeArgs['search-form'];
    $menuScode = $scodeArgs['menu-scode'];

    // GRPCAT GRPTXT GRPABC -------------------------
    $grpParts = abcfsl_util_scode_group_parts( $scodeArgs['group-id'] );
    $grpID = $grpParts['id'];
    $grpType = $grpParts['type'];
    //------------------------------------
    //$cSort = $scodeArgs['c-sort'];
    //$cSortOrder = $scodeArgs['c-sort-order'];

    //$parentID is always used to get staff member IDs.
    $tplateID = $scodeArgs['id'];
    $parentID = $tplateID;
    if( $scodeArgs['master'] > 0 ){ $parentID = $scodeArgs['master']; }

    //SCMENUID
    $scodeMenuID = $scodeArgs['menu-id'];
    //=============================================================
    $tplateOptns = get_post_custom( $tplateID );

    //Add excluded subcategories
    $tplateOptns = abcfsl_util_fix_cat_excluded_slugs( $tplateOptns );

    //echo"<pre>", print_r( $tplateOptns, true ), "</pre>";
    //$sPageUrl = isset( $tplateOptns['_sPageUrl'] ) ? esc_attr( $tplateOptns['_sPageUrl'][0] ) : '';
    
    //Plugin container  
    $lstCntrW = isset( $tplateOptns['_lstCntrW'] ) ? esc_attr( $tplateOptns['_lstCntrW'][0] ) : '';
    $lstACenter = isset( $tplateOptns['_lstACenter'] ) ? esc_attr( $tplateOptns['_lstACenter'][0] ) : 'Y';
    $lstCntrCls = isset( $tplateOptns['_lstCntrCls'] ) ? esc_attr( $tplateOptns['_lstCntrCls'][0] ) : '';
    $lstCntrTM = isset( $tplateOptns['_lstCntrTM'] ) ? esc_attr( $tplateOptns['_lstCntrTM'][0] ) : '';
    $lstCntrStyle = isset( $tplateOptns['_lstCntrStyle'] ) ? esc_attr( $tplateOptns['_lstCntrStyle'][0] ) : '';
    $pgnationPgQty = isset( $tplateOptns['_pgnationPgQty'] ) ? $tplateOptns['_pgnationPgQty'][0] : 0;
    $pgnationTB = isset( $tplateOptns['_pgnationTB'] ) ? $tplateOptns['_pgnationTB'][0] : 'B';
    $pgnationColor = isset( $tplateOptns['_pgnationColor'] ) ? $tplateOptns['_pgnationColor'][0] : 'G';
    $sortType = isset( $tplateOptns['_sortType'] ) ? $tplateOptns['_sortType'][0] : 'T';
    //------------------------------------------------
    
    $menuNo = $scodeMenuID;
    $hasMenu = abcfsl_util_menu_has_menu( $menuNo );
    $hasFilters = abcfsl_util_menu_has_filters( $menuNo );

    //-- MULTIFILTER START -------------------------------------
    $btn = '';
    $frmType = '';
    $filtersEmpty = true;
    $filters = abcfsl_util_filters_defaults();

    if( $hasFilters ){
        $filters = abcfsl_cnt_filter_post( $menuNo );
        $filtersEmpty = abcfsl_cnt_filters_empty( $filters );
        $btn = $filters['btn'];
        $frmType = $filters['frmType'];
        if( !empty( $searchForm ) ) { $frmType = $searchForm; }
    }
    //-- MULTIFILTER END -------------------------------------

    //No paging if there are any search criteria present.
    $pgnationPgQtyAjax = $pgnationPgQty;
    if( !$filtersEmpty ) {
        $pgnationPgQty = 0;
        $pageNo = 0;
        $tplateOptns['_pgnationPgQty'][0] = 0;
    }

    //-- AJAX -------------------------------------
    $ajaxMenu = false;
    $ajaxMFP = false;

    if( $ajax > 0 ) { 
        $ajaxMenu = true;  
        $ajaxMFP = true;
    }

    //if( !empty( $menuNo ) && $ajax > 0 )  { $ajaxMenu = true;  }
    //if( $ajax > 0 ) { $ajaxMFP = true;  }

    //------------------------------------------------
    //?????????
    //$lstImgCls = isset( $tplateOptns['_lstImgCls'] ) ? esc_attr( $tplateOptns['_lstImgCls'][0] ) : $pfix . 'ImgCenter';
    //$tplateOptns['_lstImgCls'] = array($lstImgCls);

    //-- Plugin container --------------------------------------------
    $cntCntrStyle = abcfl_css_w_responsive( $lstCntrW, $lstCntrW ) . $lstCntrStyle;
    $centerCls = abcfsl_util_center_cls( $lstACenter, $pfix );
    $cntrMarginT = abcfsl_util_cls_name_nc_bldr( $lstCntrTM, 'MT', $pfix );
    $cntCntrCustomCls = $lstCntrCls . $cntrMarginT . $centerCls . ' SL_' . $scodeArgs['tplate'] . '_v' . $scodeArgs['pversion'];
    $gridCntr = abcfsl_cnt_generic_div( $pfix, 'GridCntr', $cntCntrCustomCls, $cntCntrStyle, '', $tplateID, 'Y', false);

    //-- Get menu -------------------------------------
    //Returns array: HTML, menu options and qry parameters OR qry parameters.
    //Menu HTML + menu options. Not search criteria. // MULTIFILTER
    $menu = abcfsl_util_menu_defaults();
    if( $hasMenu ) {
        $menu = abcfsl_cnt_menu_from_staff_shortcode( $menuNo, $scodeArgs, $filters, $ajaxMFP, $ajax ); 
    }

    $menuItemsHTML = $menu['menuItemsHTML'];
    if( $menuScode == 1 ) $menuItemsHTML = '';
    $menu['menuItemsHTML'] = '';

    $optns['tplateID'] =  $tplateID;
    $optns['parentID'] =  $parentID;
    $optns['pfix'] =  $pfix;
    $optns['ajax'] = $ajax;
    $optns['random'] = $scodeArgs['random'];
    $optns['scodeOrder'] = strtoupper($scodeArgs['order']);
    $optns['dSortOrder'] = strtoupper($scodeArgs['d-sort-order']); 
    $optns['dSort'] =  strtoupper($scodeArgs['d-sort']);
    $optns['cSort'] =  strtoupper($scodeArgs['c-sort']);
    $optns['cSortOrder'] = strtoupper($scodeArgs['c-sort-order']);
    $optns['scodeCat'] = $scodeArgs['category']; 
    $optns['scodeCatExcl'] = $scodeArgs['category-exclude']; 
    $optns['top'] = $scodeArgs['top'];
    $optns['staffID'] = $staffID;
    $optns['grpID'] = $grpID;
    $optns['grpType'] = $grpType;
    $optns['sortType'] = $sortType;
    
    //$optns['datePlus'] = $scodeArgs['date-plus'];
    //-- PG -------------------
    $optns['pageNo'] = $pageNo;
    $optns['pgnationPgQty'] =  $pgnationPgQty;
    //----------------------------------------------------
    $cntParts['itemsHTML'] = '';
    $cntParts['totalQty'] = 0;
    $cntParts['sdProperties'] = array();
    $cntParts['js'] = '';
    $cntParts['pgnCnt'] = '';
    $cntParts['ldjsonSD'] = '';


    // SFORM SEARCH FORM
    $showRecords = true;
    if( $btn == 'reset' && $frmType == 'SF' ) { $showRecords = false; }

    if( $filtersEmpty ) {
        if( $btn == 'search' && $frmType == 'SF' ) { $showRecords = false; }
    }

    // AJAX
    //ISOTOPE ???
     //Returns cntParts. Takes menu options. Returns filtered grid based on menu options.
    if( $showRecords ) {
        switch ( $scodeArgs['tplate'] ) {
            case 'A' :
                $cntParts = abcfsl_cnt_grid_a( $tplateOptns, $optns, $menu, $filters );
                break;
            case 'B' :
                $cntParts = abcfsl_cnt_grid_b( $tplateOptns, $optns, $menu, $filters );
                break;
            case 'C' :
                $cntParts = abcfsl_cnt_grid_c( $tplateOptns, $optns, $menu, $filters );
                break;                
            case 'L' :
                $cntParts = abcfsl_cnt_list( $tplateOptns, $optns, $menu, $filters );
                break;
            default:
                break;
        }
    }

    //== AJAX START ==================================
    if( $staffID > 0 ) { $ajax = 0;}

    $jsAjax = '';
    $ajaxItemsS = '';
    $ajaxDivE = '';
    $ajaxSdS = '';
    $ajaxPgnS = '';
    $ajaxLoader = '';

    //????????????????????????????????????????
    $pgnCnt = $cntParts['pgnCnt'];
    $pgnT = '';
    $pgnB = '';

    if ( $pgnationTB == 'T' ){ $pgnT = $pgnCnt; }
    else { $pgnB = $pgnCnt; }

    $ajaxPar['ajax'] = $ajax;
    $ajaxPar['tplateID'] = $tplateID;
    $ajaxPar['parentID'] = $parentID;
    $ajaxPar['pfix'] = $pfix;
    $ajaxPar['scodeArgs'] = $scodeArgs;
    $ajaxPar['scodeMenuID'] = $scodeMenuID;
    $ajaxPar['pgnationPgQty'] = $pgnationPgQtyAjax;
    $ajaxPar['menu'] = $menu;
    $ajaxPar['filters'] = $filters;
    //$ajaxPar['filtersEmpty'] = $filtersEmpty;
    $ajaxPar['sortType'] = $sortType;
    $ajaxPar['pgnationColor'] = $pgnationColor;
    $ajaxPar['ajaxMenu'] = $ajaxMenu;
    $ajaxPar['ajaxMFP'] = $ajaxMFP;

    if( $ajax > 0 ) {
        $jsPar = abcfsl_js_params( $ajaxPar );
        $jsAjax = abcfsl_cnt_js_ajax( $jsPar );

        $ajaxItemsS = abcfl_html_tag( 'div', '', $jsPar['clsItemsCntr'], '' );
        $ajaxSdS = abcfl_html_tag( 'div', '', $jsPar['clsSDCntr'], '' );
        $ajaxPgnS = abcfl_html_tag( 'div', $jsPar['clsPgnCntr'], '', '' );
        $ajaxDivE = abcfl_html_tag_end( 'div' );

        if(!empty( $pgnT )) { $pgnT = $ajaxPgnS . $pgnT . $ajaxDivE; }
        if(!empty( $pgnB )) { $pgnB = $ajaxPgnS . $pgnB . $ajaxDivE; }

        //Ajax pagination container for ALL last.
        if( empty( $pgnT )  &&  empty( $pgnB ) ) { 
            if( $pgnationPgQtyAjax > 0 ) {
                if ( $pgnationTB == 'T' ){   
                    $pgnT = $ajaxPgnS . $ajaxDivE;                  
                }
                else { 
                    $pgnB = $ajaxPgnS . $ajaxDivE;
                 }
            }
         }

        $ajaxLoader = abcfsl_util_ajax_loader( 'ajax-loader-bert-gray.gif', $ajax, $pfix );
    }
    //== AJAX END ==================================

    //Render page
    $cntHTML = $menuItemsHTML .
            $gridCntr['cntrS'] .
            $pgnT .
            $ajaxLoader .
            $ajaxItemsS .
            $cntParts['itemsHTML'] .
            $ajaxDivE .
            $pgnB .
            $gridCntr['cntrE'];

    //Structured data
    $jsonLdSD = $ajaxSdS . $cntParts['ldjsonSD'] .  $ajaxDivE;

    return $jsAjax . $cntHTML . $jsonLdSD;
}

//==================================================================
function abcfsl_cnt_generic_div( $pfix, $baseCls, $customCls, $customStyle, $divID, $itemID, $addItemCls, $isSingle ){

    $cntrCls = abcfsl_cnt_class_bldr( $pfix, $baseCls, $customCls, $isSingle, $addItemCls, $itemID );

    $div['cntrS'] = abcfl_html_tag( 'div', $divID, $cntrCls, $customStyle );
    $div['cntrE'] = abcfl_html_tag_end( 'div');

    return $div;
}

function abcfsl_cnt_generic_div_simple( $customCls, $customStyle, $divID='' ){
    return abcfsl_cnt_generic_div( '', '', $customCls, $customStyle, '', $divID, '', 'N', false );
}

//Returns classes
function abcfsl_cnt_class_bldr( $pfix, $baseCls, $customCls, $isSingle=false, $addItemCls='N', $itemID='0' ){

    $cntrBaseCls = '';
    if( !empty( $baseCls ) ){ $cntrBaseCls = $pfix . $baseCls; }
    $custCls = abcfsl_util_pg_type_cls_bldr( $customCls, $isSingle );

    $itemCls = '';
    if($addItemCls == 'Y'){ $itemCls = ' ' . $cntrBaseCls . '_' . $itemID; }

    return  trim( $cntrBaseCls . ' ' . $custCls . $itemCls );
}

function abcfsl_cnt_item_inner_cntr( $custCls, $custStyle, $itemCustCls, $itemID ){

    $out['cntrS'] = '';
    $out['cntrE'] = '';
    if ( empty( $custCls ) && empty( $custStyle ) && empty( $itemCustCls ) ) { return $out; } 

    $iID = '';
    $custCls = trim($custCls . ' ' . $itemCustCls);
    if ( !empty( $itemCustCls ) ){ $iID = $itemID; }

    $out['cntrS'] = abcfl_html_tag( 'div', $iID, $custCls, $custStyle );
    $out['cntrE'] = abcfl_html_tag_end( 'div');
    return $out;
}

function abcfsl_cnt_item_cntr( $custCls, $custStyle, $requiredCls, $itemID, $itemCustCls ){

    $iID = '';
    if ( !empty( $custCls ) ){ $custCls = ' ' . $custCls; }
    if( !empty( $itemCustCls ) ) { 
        $itemCustCls = ' ' . $itemCustCls; 
        $iID = $itemID;
    }
    
    $divCls = $requiredCls . $custCls . $itemCustCls . ' abcfClrFix';
    //Item container DIV
    $div['itemCntrS'] = abcfl_html_tag( 'div', $iID, $divCls , $custStyle );
    $div['itemCntrE'] = abcfl_html_tag_end( 'div');
    return $div;
}

function abcfsl_cnt_filters_empty( $filters ){

    //Array ( [1] => * [2] => * [3] => [4] => [5] => [6] => [btn] => search [frmType] => ) 
    //Check only first 6 items.
    $empty = true;
    for ($x = 1; $x <= 6; $x++) {        
        if( !empty( $filters[$x] ) ){ 
            if( $filters[$x] == '*' ) { continue; }           
            $empty = false;
            break;
        }
    }
    return $empty;
}